###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$boardindexplver = "1 Gold - SP 1.3";

sub BoardIndex {
	require "$vardir/shoutbox_vars.pl";
	$shout_rowspan = ($username eq 'Guest') ? $shout_rowspan : $shout_rowspan - 2;
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		my($mscount);
		$mscount=0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if($settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);

			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;

if($username ne "Guest") {
$yymain .= qq~

<SCRIPT LANGUAGE="JavaScript1.2">

img1 = new Image(); img1.src = "$imagesdir/100_glad.gif";
img2 = new Image(); img2.src = "$imagesdir/110_tilfreds.gif";
img3 = new Image(); img3.src = "$imagesdir/120_sej.gif";
img4 = new Image(); img4.src = "$imagesdir/130_normal.gif";
img5 = new Image(); img5.src = "$imagesdir/140_fjoget.gif";
img6 = new Image(); img6.src = "$imagesdir/150_svimmel.gif";
img7 = new Image(); img7.src = "$imagesdir/160_flov.gif";
img8 = new Image(); img8.src = "$imagesdir/170_bekymret.gif";
img9 = new Image(); img9.src = "$imagesdir/180_bedrovet.gif";
img10 = new Image(); img10.src = "$imagesdir/190_vred.gif";
img11 = new Image(); img11.src = "$imagesdir/200_sleepy.gif";

var delEnh=80, totEnh=80;

var Imgs = [
"100_glad",
"110_tilfreds",
"120_sej",
"130_normal",
"140_fjoget",
"150_svimmel",
"160_flov",
"170_bekymret",
"180_bedrovet",
"190_vred",
"200_sleepy"
]

var eleNum = Imgs.length, theNum = Imgs.length, ele

function showImg() {
	eleDiv = totEnh/eleNum;
	ele = Math.round(delEnh/eleDiv);
	if (ele < 0) ele = 0;
	if (ele >= eleNum) ele = eleNum-1;
	if (knapObj.id == "knapImg" && ele != theNum) {
		document.images.imag.src="$imagesdir/"+Imgs[ele]+".gif";
		theNum = ele;
	}
}


function saveImg() {
skydNu=false;
location.href="$cgi;action=savemembmood;themood="+Imgs[ele];
}

var ie=document.all
var ns6=document.getElementById&&!document.all

var skydNu=false
var x, knapObj, retning

function flytKnap(e) {
	if (skydNu) {
		glX = parseInt(knapObj.style.left+0)
		knapObj.style.left=ns6? temp2 + e.clientX - x : temp2 + event.clientX - x
		nyX = parseInt(knapObj.style.left+0)
		if (nyX > glX) retning = "vn"
		else retning = "hj"
		if (nyX < 4 && retning == "hj") { knapObj.style.left = 4; retning = "vn"; }
		if (nyX > 84 && retning == "vn") { knapObj.style.left = 84; retning = "hj"; }
		delEnh = parseInt(knapObj.style.left+0)-4
		showImg()
		document.onmouseup=saveImg
		return false
	}
}

function skydeKnap(e){
if (!ie&&!ns6) return
var flytobj=ns6? e.target : event.srcElement
var topelement=ns6? "HTML" : "BODY"
	while (flytobj.tagName != topelement && flytobj.className != "skyd"){
		flytobj=ns6? flytobj.parentNode : flytobj.parentElement
	}
	if (flytobj.className=="skyd"){
		skydNu=true
		knapObj=flytobj
		temp2 = parseInt(knapObj.style.left+0)
		x=ns6? e.clientX : event.clientX
		document.onmousemove=flytKnap
		return false
	}
}
document.onmousedown=skydeKnap
</SCRIPT>
~;
$thistime = time;
if(-e ("$memberdir/$username.mim")) {
	fopen(FILE,"$memberdir/$username.mim");
	@mimood = <FILE>;
	fclose(FILE);
	chomp $mimood;
	if(($thistime-$mimood[1]) < 86400) { $moodgif = $mimood[0]; }
	else { $moodgif = "100_glad"; }
}
else { $moodgif = "100_glad"; }
$yymain .= qq~
<table width="100%" align="center" border="0" cellspacing="0" cellpadding="0">
<tr>
<td align="left" valign="bottom">
<font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>
</td>
<td width="100" align="center" valign="bottom">
<img src="$imagesdir/$moodgif.gif" name="imag" height="60" width="60" border="0" align="absmiddle"><br>
</td>
<td width="110" align="left" valign="top">
<font size="1">
$mimtxt{'01'} $realname?
</font>
<div style="position: relative; z-index: 1; width: 102; height: 24; left: 0; top: 4; border-width: 2px; border-style: outset; background-color: #AAAAAA">
<img src="$imagesdir/knapbagr.gif" style="position: absolute; z-index: 2; width: 100; height: 20; left: 0; top: 0">
<img id="knapImg" src="$imagesdir/knap.gif" class="skyd" style="cursor: pointer; cursor: hand; z-index: 3; width: 13; height: 15; left: 4; top: 3">
</div>
</td>
</tr>
</table>

~;
}
else {
	$yymain .= qq~
<P align="left"><font size="2" class="nav"><IMG SRC="$imagesdir/open.gif" BORDER="0" alt=""> <b>$curforumurl</b></font>~;
}

	if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2" valign="middle" align="center" height="60">
<script language="JavaScript1.2" type="text/javascript">
<!--
var delay = $fadertime
var bcolor = "$color{'windowbg2'}"
var tcolor = "$color{'fadertext'}"
var fcontent = new Array()
begintag = '<font size="2"><B>'
~;
fopen(FILE, "$vardir/news.txt");
@newsmessages = <FILE>;
fclose(FILE);
for($i=0; $i < @newsmessages; $i++) {
	$newsmessages[$i] =~ s/\n|\r//g;
	if($i != 0){ $yymain .= qq~\n~; }
	$message = $newsmessages[$i];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$message =~ s/\"/\\\"/g;
	$yymain .= qq~fcontent[$i] = "$message"~;
}
$yymain .= qq~
closetag = '</b></font>'
// -->
</script>
<script language="JavaScript1.2" type="text/javascript" src="$faderpath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
if (navigator.appVersion.substring(0,1) < 5 && navigator.appName == "Netscape") {
   var fwidth = screen.availWidth / 2;
   var bwidth = screen.availWidth / 4;
   document.write('<ilayer id="fscrollerns" width='+fwidth+' height=35 left='+bwidth+' top=0><layer id="fscrollerns_sub" width='+fwidth+' height=35 left=0 top=0></layer></ilayer>');
   window.onload = fade;
}
else if (navigator.userAgent.search(/Opera/) != -1 || (navigator.platform != "Win32" && navigator.userAgent.indexOf('Gecko') == -1)) {
   document.open();
   document.write('<div id="fscroller" style="width:90%; height:15px; padding:2px">');
   for(i=0; i < fcontent.length; ++i) {
      document.write(begintag+fcontent[i]+closetag+'<br>');
   }
   document.write('</div>');
   document.close();
   window.onload = fade;
}
else {
   document.write('<div id="fscroller" style="width:90% height:15px; padding:2px"></div>');
   window.onload = fade;
}
// -->
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
      </tr>~;

	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>
      </tr>~;
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <font size="2"><a name="$curboard" href="$scripturl?board=$curboard">$boardpic{$curboard}<b>$curboardname $boardpwpic</b></a></font>
        <br><font size="1">$curboarddescr<BR>
        <i>$showmods</i></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$lastposttime{$curboard}<BR>$txt{'525'} $lastposter <a href="$scripturl?board=$curboard;action=gotolastpost"><img src="$imagesdir/gotolastpost.gif" border="0"></a></font></td>
      </tr>~;
		}
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	fopen(FILE, "$vardir/log.txt");
	@entries = <FILE>;
	fclose(FILE);
	foreach $curentry (@entries) {
		chomp $curentry;
		($name, $value) = split(/\|/, $curentry);
		if($name) {
			if(!$yyUDLoaded{$musername}) { &LoadUser($name); }
			if(exists $userprofile{$name}) {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size="1">,</font> \n~;
			}
			else { $guests++; }
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
### AIMB START ###
if($userimcfg[5] eq "on") {
$yymain .= qq~<script language="javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~; }
else {
$yymain .= qq~<script language="javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~; }

if ($minnum == $numibox && $enable_imlimit) {
	$yymain .= qq~<script language="javascript">
	if(confirm('$imtxt{'91'}')) { viewinstant(); } else cancel() </script>~;
}

if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IM; 
}

if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IMOUT; 
}

if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $storenum $imtxt{'12'} $imtxt{'46'}!\\n$numstore $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_STORE; 
}

$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;
### AIMB END ###
		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1">
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}&nbsp;&nbsp;
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1>&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}
	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<BR><BR>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td width="176">
  <table cellpadding="4" cellspacing="1" border="0" width="175" bgcolor="$color{'titlebg'}">
     <tr>
     	 <td bgcolor="$color{'titlebg'}" class="titlebg" align="center">
         <font class="text1" color="$color{'titletext'}" size="2"><b>$shout_txt{'5'}</b></font></td>
     </tr>
     <tr>
     	<td rowspan="$shout_rowspan" class="windowbg2" bgcolor="$color{'windowbg'}" valign="top" width="1%">
     ~;
     	  
     	require "$sourcedir/Shoutbox.pl";
     	&ShoutBox;
     	
     	$yymain .= qq~</td>
     </tr>
  </table>
</td>
<td valign="top" bgcolor="$color{'tablefix'}">
    <table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'titlebg'}">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
      </tr>
      <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'200'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	    <td valign="top" align="left" width="40%"><font size="1">
	    $txt{'488'} <a href="$scripturl?action=mlall"><B>$memcount</B></a>
	    ~;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'201'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;
	}
	$yymain .= qq~
	    $ims
	    </font></td>
	  </tr>
	</table>
	</font></td>
~;
	## WHOSON MOD START ##
	if ( $guestaccess != 0 ) {
		$countonl = $numusers + $guests;
	} else {
		$countonl = $numusers;
	}
	if ( $guests == 1 ) { $uguest = qq~$guests $txt{'28'},~; }
	else { $uguest = qq~$guests $txt{'141'},~; }
	if ( $numusers == 1 ) { $uuser = qq~$numusers $who{'103'}~; }
	else { $uuser = qq~$numusers $txt{'142'}~; }
	open( FILE, "$vardir/mostuser.txt" );
	@onlcount = <FILE>;
	close( FILE );
	if ( $countonl > $onlcount[0] ) {
		fopen( FILE, ">$vardir/mostuser.txt" );
		print FILE "$countonl\n";
		print FILE "$date";
		fclose( FILE );
	}
	if ( $username ne 'Guest' ) {
		$onlcount[1] = &timeformat( $onlcount[1] );
		if ( $onlopt == 1 ) {
			if ( $countonl == 1 ) {
				$uwhoonline .= qq~&#187; <a href="$scripturl?action=who">$who{'99'} ($countonl) $who{'100a'}</a> &#171;<br>~;
			}
			else {
				$uwhoonline .= qq~&#187; <a href="$scripturl?action=who">$who{'98'} ($countonl) $who{'100b'}</a> &#171;<br>~;
			}
		}
		if ( $Show_MostUsers == 1 ) {
			$uonline .= qq~<BR>$mosttxt{'01'} $onlcount[1] $mosttxt{'02'} $onlcount[0] $mosttxt{'03'}~;
		}
	}
	## WHOSON MOD END ##
	$yymain .= qq~
      <!-- WHOSON MOD START -->
      </tr>~;
	if ($Show_OnlineBar == 1 || $Show_OnlineBar eq "") {
		$yymain .= qq~
	~;
	if($totalt > 0) {
		require "$sourcedir/TopStats.pl";
		&TopLink;
	}
	$yymain .= qq~
      <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'158'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">
            $uwhoonline$uguest $uuser<BR>$users $uonline
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
	}
      ## WHOSON MOD END ##

	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title="$txt{'34'} <small><a href=\"$cgi;action=reminder\">($txt{'315'})</a></small>";
		&sharedLogin;
	}

	$yymain .= qq~
    </table>
    </td>
<td>
###Custom Weather Mod -  Powered by http://weatherroom.com###

if($weathercentershow == '1' && ( $username ne 'Guest' )) {
 $wetbackbg = "FFFFFF";             # weather Background color
 $wetfontcolor = "000000";             # weather text font color
fopen(FILE, "$memberdir/$username.wet", 1); 
        @wetsettings = <FILE>;
        fclose <FILE>;
        chomp @wetsettings;   
            if ($wetsettings[0] ne '')
            {
$yymain .= qq~
<table>
<tr>
    <td class="catbg" bgcolor="$color{'catbg'}" colspan="2" align="center"><font size="2" class="catbg"> <img src="$imagesdir/glove.gif" border="0" width="16" height="17"><b>$txtwet{'0'}</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center">
<a href="http://www.weatherroom.com/forecast/$wetsettings[0].html"><img src="http://www.weatherroom.com/weather?forecast=zone&hwvtc=$wetfontcolor&hwvbg=$wetbackbg&pands=$wetsettings[0]&config=png&alt=hwivzone&daysonly=1" alt="Weather for $wetsettings[0] provided by weatherroom.com." border="0"></a><p align="center"><font size="1">Powered by <a href="http://www.addresses.com/weather.php">Addresses.com</a></font></center>
</td>
</tr>
</table>~;
}

  }
###Custom Weather Mod -  Powered by http://weatherroom.com####
</td>
  </tr>
<tr><td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">&nbsp;</td></tr>
</table>
<meta http-equiv="refresh" content="180; URL=http://forum.sadisticpleasures.org">
~;
	if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}

sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

sub SaveMembMood {
	$moodtime = time;
	fopen(FILE, ">$memberdir/$username.mim", 1);
		print FILE "$INFO{'themood'}\n";
		print FILE "$moodtime\n";
	fclose(FILE);
	&BoardIndex;
}

1;